.386
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include gdi32.inc
includelib gdi32.lib

;**********************************************************************************************************

WinMain proto
WndProc proto hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;**********************************************************************************************************

IDB_MYBMP       equ 801

IMG_WIDTH       equ 160
IMG_HEIGHT      equ 120

;**********************************************************************************************************

.data
AppName     db "It's a bitmap!!",0
ClassName   db "bimp",0

.data?
hInstance   HINSTANCE   ?
hWnd        HWND        ?

hBmp        HBITMAP     ?           ;the handle of our bitmap (from resource)
hDCBmp      HDC         ?           ;a DC to draw the actual pixels of the bitmap into (sort of unpacking buffer)

.code
start:
    invoke GetModuleHandle, NULL
    mov hInstance,eax
    invoke WinMain
    invoke ExitProcess, eax

;** App window stuff **************************************************************************************
WinMain proc
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    mov wc.cbSize,SIZEOF wc
    mov wc.style,CS_HREDRAW or CS_VREDRAW
    mov wc.lpfnWndProc,OFFSET WndProc
    mov wc.cbClsExtra,NULL
    mov wc.cbWndExtra,NULL
    mov eax,hInstance
    mov wc.hInstance,eax
    mov wc.hbrBackground,COLOR_WINDOW+1
    mov wc.lpszMenuName,NULL
    mov wc.lpszClassName,OFFSET ClassName
    invoke LoadIcon, NULL,IDI_APPLICATION
    mov wc.hIcon,eax
    mov wc.hIconSm,eax
    invoke LoadCursor, NULL,IDC_ARROW
    mov wc.hCursor,eax
    invoke RegisterClassEx, ADDR wc
    invoke CreateWindowEx, NULL,ADDR ClassName,ADDR AppName,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,200,160,NULL,NULL,hInstance,NULL
    .IF (eax)
        mov hWnd,eax
        invoke ShowWindow, hWnd,SW_SHOWDEFAULT
        invoke UpdateWindow, hWnd
        .WHILE TRUE
            invoke GetMessage, ADDR msg,NULL,0,0
            .BREAK .IF(!eax)
            invoke TranslateMessage, ADDR msg
            invoke DispatchMessage, ADDR msg
        .ENDW
        mov eax,msg.wParam
    .ENDIF
    ret
WinMain endp

WndProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    LOCAL ps:PAINTSTRUCT
    LOCAL hDC:HDC
    mov eax,uMsg
;-- WM_PAINT ----------------------------------------------------------------------------------------
    .IF (eax==WM_PAINT)
        invoke BeginPaint, hwnd,ADDR ps
        mov hDC,eax

        invoke BitBlt, hDC,0,0,IMG_WIDTH,IMG_HEIGHT,hDCBmp,0,0,SRCCOPY       ;just copy the pixels from memory onto the window's DC

        invoke EndPaint, hwnd,ADDR ps
;-- WM_CREATE ---------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_CREATE)
        invoke LoadBitmap, hInstance,IDB_MYBMP          ;load the bitmap from the resource into memory (useable)
        mov hBmp,eax

        push ebx
        invoke GetDC, hwnd
        mov ebx,eax

        invoke CreateCompatibleDC, ebx
        mov hDCBmp,eax
        invoke SelectObject, hDCBmp,hBmp                ;get the bitmap actually drawn into memory

        invoke ReleaseDC, hwnd,ebx
        pop ebx

;-- WM_DESTROY --------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_DESTROY)
        ;don't forget to cleanup! (they need to be done is this order too)
        invoke DeleteDC, hDCBmp
        invoke DeleteObject, hBmp
        invoke PostQuitMessage, NULL
;-- default -----------------------------------------------------------------------------------------
    .ELSE
        invoke DefWindowProc, hwnd,uMsg,wParam,lParam
        ret
    .ENDIF
    xor eax,eax
    ret
WndProc endp

end start
